=== share/rings/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (c) 2010-2022 Belledonne Communications SARL.
#
############################################################################
#
# This file is part of Liblinphone 
# (see https://gitlab.linphone.org/BC/public/liblinphone).
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

set(RING_FILES
	"${CMAKE_CURRENT_SOURCE_DIR}/oldphone-mono.wav"
	"${CMAKE_CURRENT_SOURCE_DIR}/four_hands_together.mkv"
	"${CMAKE_CURRENT_SOURCE_DIR}/house_keeping.mkv"
	"${CMAKE_CURRENT_SOURCE_DIR}/its_a_game.mkv"
	"${CMAKE_CURRENT_SOURCE_DIR}/leaving_dreams.mkv"
	"${CMAKE_CURRENT_SOURCE_DIR}/notes_of_the_optimistic.mkv"
	"${CMAKE_CURRENT_SOURCE_DIR}/soft_as_snow.mkv"
	PARENT_SCOPE
)
