=== debian/changelog ===
linphone (5.3.105-6ubuntu2) questing; urgency=medium

  * Stick with O2 on ppc64el to fix gcc build failure

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 29 Aug 2025 09:43:19 +0200

linphone (5.3.105-6) unstable; urgency=medium

  * Team upload

  [ Matthias Klose ]
  * Fix build with libxml 2.14.x

 -- Bastian Germann <bage@debian.org>  Fri, 22 Aug 2025 09:36:35 +0200

linphone (5.3.105-5) unstable; urgency=medium

  * Team upload
  * Add Depends referenced by .pc file

 -- Bastian Germann <bage@debian.org>  Fri, 21 Mar 2025 21:16:07 +0100

linphone (5.3.105-4) unstable; urgency=medium

  * Team upload
  * Disable FlexiAPI because libjsoncpp has wrong libname

 -- Bastian Germann <bage@debian.org>  Tue, 04 Mar 2025 22:04:32 +0100

linphone (5.3.105-3) unstable; urgency=medium

  * Team upload
  * Add directory referenced in .cmake

 -- Bastian Germann <bage@debian.org>  Tue, 04 Mar 2025 18:31:01 +0100

linphone (5.3.105-2) unstable; urgency=medium

  * Team upload
  * Drop shlibs.local

  [ Daniel Kahn Gillmor ]
  * Actually require LINPHONE_DO_APPIMAGE_DOWNLOAD=y for AppImage download

 -- Bastian Germann <bage@debian.org>  Mon, 03 Mar 2025 13:23:16 +0100

linphone (5.3.105-1) unstable; urgency=medium

  * Team upload
  * New upstream version 5.3.105 (Closes: #1099181, #1094046)
  * Refresh copyright info
  * Refresh patches
  * Move from custom ENABLE_SHARED to BUILD_SHARED_LIBS
  * Build without readline patch

 -- Bastian Germann <bage@debian.org>  Sat, 01 Mar 2025 15:36:45 +0100
