=== debian/control ===
Source: linphone
Section: sound
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Kilian Krause <kilian@debian.org>,
           Tzafrir Cohen <tzafrir@debian.org>,
           Felix Lechner <felix.lechner@gmail.com>,
           Bernhard Schmidt <berni@debian.org>,
Build-Depends: cmake,
               debhelper-compat (= 13),
               doxygen,
Build-Depends-Indep: graphviz,
Build-Depends-Arch: libbctoolbox-dev (>= 5.2.98~),
                    libbelcard-dev (>= 5.2.98~),
                    libbellesip-dev (>= 5.2.98~),
                    libbelr-dev (>= 5.2.98~),
                    libboost-dev,
# Ever since switching to LIME_X3DH liblinphone no longer links with brztp,
# but the build scripts were not reworked, so we still need this.
                    libbzrtp-dev (>= 5.2.98~),
                    libldap2-dev,
                    liblime-dev (>= 5.2.98~),
                    libmediastreamer-dev (>= 1:5.2.98+dfsg~),
                    libortp-dev (>= 1:5.2.98~),
                    libreadline-dev,
                    libsoci-dev (>= 4.0.1-4~),
                    libsqlite3-dev,
                    libturbojpeg0-dev,
                    libudev-dev,
                    libxerces-c-dev,
                    libzxing-dev,
                    python3-pystache,
                    python3-six,
                    xsdcxx,
                    zlib1g-dev,
Standards-Version: 4.6.2
Homepage: https://www.linphone.org/
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/linphone
Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/linphone.git
Description: SIP softphone - core library

Package: liblinphone-dev
Section: libdevel
Depends: liblinphone12 (= ${binary:Version}),
         liblinphone++12 (= ${binary:Version}),
         libbelcard-dev (>= 5.2.98~),
         libbellesip-dev (>= 5.2.98~),
         libbelr-dev (>= 5.2.98~),
         liblime-dev,
         libmediastreamer-dev (>= 5.2.98~),
         libortp-dev (>= 5.2.98~),
         libsqlite3-dev,
         libxml2-dev,
         ${misc:Depends},
Architecture: any
Multi-Arch: same
Description: Linphone web phone's library - development files
 Linphone is an audio and video internet phone using the SIP protocol. It
 has a GTK+ and console interface, includes a large variety of audio and video
 codecs, and provides IM features.
 .
 This package contains the files needed to use the linphone's library in your
 programs.

Package: liblinphone12
Section: libs
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
# the identity_grammar file is needed to use certain features
         linphone-common (= ${source:Version}),
Architecture: any
Multi-Arch: same
Description: Linphone's shared library part (supporting the SIP protocol)
 Linphone is an audio and video internet phone using the SIP protocol. It
 has a GTK+ and console interface, includes a large variety of audio and video
 codecs, and provides IM features.
 .
 This package contains the shared runtime libraries.

Package: liblinphone++12
Section: libs
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Architecture: any
Multi-Arch: same
Description: Linphone's shared library part (supporting the SIP protocol)
 Linphone is an audio and video internet phone using the SIP protocol. It
 has a GTK+ and console interface, includes a large variety of audio and video
 codecs, and provides IM features.
 .
 This package contains the C++ shared runtime libraries.

Package: linphone-common
Depends: ${misc:Depends},
Architecture: all
Multi-Arch: foreign
Description: Shared components of the linphone SIP softphone
 Linphone is an audio and video internet phone using the SIP protocol. It
 has a GTK+ and console interface, includes a large variety of audio and video
 codecs, and provides IM features.
 .
 This package contains the resource files of linphone (the rings).

Package: linphone-cli
Depends: host,
         liblinphone12 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Replaces: linphone-nogtk (<< 4.4.0-2~)
Breaks: linphone-nogtk (<< 4.4.0-2~)
Suggests: espeak|espeak-ng-espeak,
Architecture: any
Description: SIP softphone - console-only client
 Linphone is an audio and video internet phone using the SIP protocol. It
 has a GTK+ and console interface, includes a large variety of audio and video
 codecs, and provides IM features.
 .
 This package contains the console version of linphone.
