=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/archive\/(\d\S+)\/liblinphone.*\.tar\.gz/linphone-$1\.tar\.gz/g \
  https://gitlab.linphone.org/BC/public/liblinphone/tags?sort=updated_desc .*/archive/([\d\.]+)/.*\.tar\.gz.*
